use crate::error::CustomError;

use super::full_lines_iterator::GetFullLines;
use super::registry::Registry;

#[derive(Debug)]
pub(crate) struct ISrcBlock {
    pub(crate) lines: Vec<String>,
}

impl ISrcBlock {
    pub(crate) async fn new<'parse>(
        registry: &mut Registry<'parse>,
        original: &organic::types::SrcBlock<'parse>,
    ) -> Result<ISrcBlock, CustomError> {
        let lines = original
            .contents
            .full_lines()
            .map(|s| s.to_owned())
            .collect();
        Ok(ISrcBlock { lines })
    }
}
